#ifndef GETETHERADDRESS_HH
#define GETETHERADDRESS_HH

/*
 * =c
 * GetEtherAddress
 * =s routing table
 * annotate packet with ethernet source address
 * =d
 * Looks at incoming ethernet packets and stores the
 * source address in user annotation 1-7.
 *
 * =a RoutingTable, Paint
 */

#include <click/element.hh>
#include <click/glue.hh>

#ifdef CLICK_SIM
namespace CLICKSIM {
#endif

class GetEtherAddress : public Element {
  
 public:
  
  GetEtherAddress();
  ~GetEtherAddress();
  
  const char *class_name() const		{ return "GetEtherAddress"; }
  const char *processing() const		{ return AGNOSTIC; }
  
  GetEtherAddress *clone() const;
  int initialize(ErrorHandler *);

  Packet *simple_action(Packet *);

};

#ifdef CLICK_SIM
}
#endif

#endif
