/*
 * markadhocheader.{cc,hh} -- element sets ad hoc header annotation
 * Audun Tornquist
 */

#include <click/config.h>
#include <click/package.hh>
#include "markadhocheader.hh"
#include <click/confparse.hh>
#include <click/click_ip.h>

#ifdef CLICK_SIM
using namespace CLICKSIM;
#endif

MarkAdhocHeader::MarkAdhocHeader()
  : Element(1, 1)
{
  MOD_INC_USE_COUNT;
}

MarkAdhocHeader::~MarkAdhocHeader()
{
  MOD_DEC_USE_COUNT;
}

MarkAdhocHeader *
MarkAdhocHeader::clone() const
{
  return new MarkAdhocHeader();
}

int
MarkAdhocHeader::configure(const Vector<String> &conf, ErrorHandler *errh)
{
  _offset = 0;
  return cp_va_parse(conf, this, errh,
		     cpOptional,
		     cpUnsigned, "offset to header", &_offset,
		     0);
}

Packet *
MarkAdhocHeader::simple_action(Packet *p)
{
  p->set_user_anno_c(9, _offset);

  return p;
}

EXPORT_ELEMENT(MarkAdhocHeader)
ELEMENT_MT_SAFE(MarkAdhocHeader)
