#ifndef MARKADHOCHEADER_HH
#define MARKADHOCHEADER_HH

/*
 * =c
 * MarkAdhocHeader([OFFSET])
 * =s annotations
 * sets header annotation
 * =d
 *
 * Sets the ad hoc user annotation which is used by packet that process ad hoc specific
 * headers.  OFFSET is the number of bytes into the packet that the header is located.
 * Default is 0.
 *
 * =a MarkIPHeader */

#include <click/element.hh>

#ifdef CLICK_SIM
namespace CLICKSIM {
#endif

class MarkAdhocHeader : public Element {

  int _offset;
  
 public:
  
  MarkAdhocHeader();
  ~MarkAdhocHeader();
  
  const char *class_name() const		{ return "MarkAdhocHeader"; }
  MarkAdhocHeader *clone() const;
  int configure(const Vector<String> &, ErrorHandler *);

  Packet *simple_action(Packet *);
  
};

#ifdef CLICK_SIM
}
#endif

#endif
