#include <stdio.h>
#include <assert.h>

// ID is an element of a route. The attributes are node_id and the cost to get 
// to the ID
class ID
{
  public:
  int node_id;
  double  to_cost;

  ID()
  {
   	node_id=0;
   	to_cost=0;
  }

  ID(int i)
  {
    	node_id=i;
    	to_cost=0;
  }
  ID(int i,double j)
  {
   node_id=i;
   to_cost=j;
  }
};


class Path
{
// A Path is a sequence of node IDs that give a route
// Hence they will have a private member as len that will
//store length of the route.
// Use appendToPath function to add a  node ID to the Path instance
// Use the length function to obtain the length of the route
// Access the ith hop of the route as Path[i]


  private:
   int len;
   int cur_index;
   ID * path;
   
  public :
  
    Path()
    {
      	path=new ID[15];//MAX_SRC_LEN
      	len=0;
      	cur_index=0;
    }

   void reset()
   {
     len=0;
   }  

    void appendToPath(ID id)
    {
      assert(len<15);//MAX_SRC_LEN
      path[len].node_id =id.node_id;
      path[len].to_cost =id.to_cost;
     len++;
    }

    ID & operator[] (int n) const
    {
      return path[n];
     }

    int length() const
    {
      return len;
    } 
};
