

#include <click/element.hh>
#include <click/etheraddress.hh>
#include <click/ipaddress.hh>
#include <click/timer.hh>
#include <click/hashmap.hh>
#include <click/click_adhoc.hh>
#include <assert.h>
#include <stdio.h>
#include <string.h>

class PathIPAddress
{
// A PathIPAddress is a sequence of IPAddress elements that give a route
// Hence they will have a private member as len that will
//store length of the route.
// Use appendToPath function to add a  IPAddress to the Path instance
// Use the length function to obtain the length of the route
// Access the ith hop of the route as Path[i]


  private:
   int len;
   int cur_index;
   IPAddress * path;
   
  public :
  
    PathIPAddress()
    {
      	path=new IPAddress[15];//MAX_SRC_LEN
      	len=0;
      	cur_index=0;
    }

   void reset()
   {
     len=0;
   }  

    void appendToPath(IPAddress id)
    {
      assert(len<15);//MAX_SRC_LEN
      path[len]=id;
     len++;
    }

    IPAddress & operator[] (int n) const
    {
      return path[n];
     }

    int length() const
    {
      return len;
    } 
};









