/* 
	ORIGINAL VERSION 
	Added dynamic mapping for the nsclick simulations
*/
#include <click/config.h>
#include <click/package.hh>
#include <click/click_ether.h>
#include <click/etheraddress.hh>
#include <click/ipaddress.hh>
#include <click/confparse.hh>
#include <click/bitvector.hh>
#include <click/error.hh>
#include <click/glue.hh>
#include <click/click_dsr.hh>
#include <click/click_adhoc.hh>
#include <click/click_ip.h>
#include <click/router.hh>
#include <click/maptable.hh>

MapTable::MapTable()
{
	_num_addr = 0;
	_ipaddress = new IPAddress[MAP_TABLE_SIZE];
}

int MapTable::addEntry(IPAddress ip)
{
	_num_addr++;

	_ipaddress[_num_addr-1] = ip;
	_nodeid[_num_addr-1] = _num_addr;

	return _num_addr;
}

int MapTable::getnodeid(int i)
{
	return _nodeid[i];
}

IPAddress MapTable::getipaddress(int i)
{
	return _ipaddress[i];
}

int MapTable::ConvertIPtoNode(IPAddress ipaddress)
{
	int i;
	
	for (i=0;i<_num_addr;i++)
	{
		if ( getipaddress(i) == ipaddress )
			return getnodeid(i);
	}
	return -1;
}		
	

IPAddress MapTable::ConvertNodetoIP(int nodeid)
{

	int i;
	
	for (i=0;i<MAP_TABLE_SIZE;i++)
	{
		if ( getnodeid(i)==nodeid )
			return getipaddress(i);
	}


}

void MapTable::ConvertPathtoIP(Path& p, PathIPAddress& path_ip)
{
  for(int i=0;i<p.length();i++)
  {
    IPAddress id;
    id=ConvertNodetoIP(p[i].node_id);
    path_ip.appendToPath(id);
  }
}

void MapTable::ConvertIPtoPath(PathIPAddress &path_ip,Path &p)
{
	int ret_value;
  for(int i=0;i<path_ip.length();i++)
  {
    ID id; 
    ret_value=ConvertIPtoNode(path_ip[i]);
	if (ret_value == -1)
		id.node_id = addEntry(path_ip[i]);
	else
		id.node_id = ret_value;
    p.appendToPath(id);
  }
}













